--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")

local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 1}
local InkedColorsHightlight = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 0.5}

local HightlightTex = "Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsHoverTex"
local PushedTex = "Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsPushedTex"

local ButtonSize = 40
local MySpacing = 1
local BorderSize = 12
local BorderPadding = 0

local MoverStance = CreateFrame("Frame","StanceDrag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	--MoverStance:SetSize((ButtonSize * 12)+12, ButtonSize)
	--MoverStance:SetPoint("CENTER", UIParent,"BOTTOM",220.5, 65.5)
	MoverStance:SetFrameStrata("FULLSCREEN_DIALOG")
	MoverStance:SetClampedToScreen(true)
	MoverStance:SetClampRectInsets(0, 0, 0,0)
local MoverStanceText  = MoverStance:CreateFontString(nil, "OVERLAY")
	MoverStanceText:SetFont("Interface\\Addons\\Inked\\Fonts\\Cooline.TTF", 15, "OUTLINE")
	MoverStanceText:SetPoint("CENTER",MoverStance,"CENTER", 0,0); 
	MoverStanceText:SetText("")

local function UpdateMe()
	if(Inked.db.profile.lockframes == false) then
		local point, relativeTo, relativePoint, xOfs, yOfs = MoverStance:GetPoint(n)
			Inked.db.profile.MoverStanceX = xOfs
			Inked.db.profile.MoverStanceY = yOfs
			Inked.db.profile.MoverStancePoint = point
			MoverStanceText:SetText("Stance")				
	end	
end	

local InkedSettingsFrame = CreateFrame("Frame")	
	InkedSettingsFrame:HookScript("OnUpdate",UpdateMe) 
local function CreateMoverBackdrop(frame)
	frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
	insets = {top = -2, left = -2, bottom = -2, right = -2}})
	frame:SetBackdropColor(0,0.55,0.95,0.45)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function MakeBarStance()
	if Inked.db.profile.UseActionBars == false then return end
	local BarStanceholder = CreateFrame("Frame", "BarStanceholder", UIParent, "SecureHandlerStateTemplate")
	BarStanceholder:ClearAllPoints()
		

	ButtonSize = Inked.db.profile.StanceButtonSize
	local ThisTexture = ("Interface\\Addons\\Inked\\Graphics\\Buttons\\InkedButtons")
		
		

		for i = 1, NUM_STANCE_SLOTS do
			local InkedBar1 = _G["StanceButton"..i]
			_G["StanceButton"..i]:SetWidth(ButtonSize)
			_G["StanceButton"..i]:SetHeight(ButtonSize)
			_G["StanceButton"..i]:CreateBeautyBorder(BorderSize)
			_G["StanceButton"..i]:SetBeautyBorderPadding(BorderPadding)
			_G["StanceButton"..i]:SetBeautyBorderTexture("white")
			--_G["StanceButton"..i]:SetBeautyBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
			if Inked.db.profile.ClassABColor == true then
				_G["StanceButton"..i]:SetBeautyBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
			elseif Inked.db.profile.ClassABColor == false then
				if Inked.db.profile.CustomABColor == true then
					_G["StanceButton"..i]:SetBeautyBorderColor(Inked.db.profile.ABColorR,Inked.db.profile.ABColorG,Inked.db.profile.ABColorB,Inked.db.profile.ABColorA)
				elseif Inked.db.profile.CustomABColor == false then
					_G["StanceButton"..i]:SetBeautyBorderColor(1,1,1,1)
				end
			end

			InkedBar1:SetAttribute("showgrid", 1)
			InkedBar1.NormalTexture:SetTexture("")
			local Highlight = InkedBar1:GetHighlightTexture()	
			local Pushed = InkedBar1:GetPushedTexture()
			Highlight:SetTexture(HightlightTex)
			Highlight:SetVertexColor(InkedColorsHightlight.r,InkedColorsHightlight.g,InkedColorsHightlight.b,InkedColorsHightlight.a)
			Pushed:SetTexture(PushedTex)	
			
		end
		MoverStance:SetSize((ButtonSize * NUM_STANCE_SLOTS), ButtonSize)

		if(Inked.db.profile.lockframes == false) then
			MoverStance:ClearAllPoints()
			if Inked.db.profile.MoverStancePoint == nil then
				MoverStance:SetPoint("BOTTOM", UIParent,Inked.db.profile.MoverStanceX,Inked.db.profile.MoverStanceY)
			else
				MoverStance:SetPoint(Inked.db.profile.MoverStancePoint, UIParent,Inked.db.profile.MoverStanceX,Inked.db.profile.MoverStanceY)
			end
			CreateMoverBackdrop(MoverStance)
			MoverStance:SetMovable(true)
			MoverStance:EnableMouse(true)
			MoverStance:RegisterForDrag("LeftButton")
			MoverStance:SetScript("OnDragStart", MoverStance.StartMoving)
			MoverStance:SetScript("OnDragStop", MoverStance.StopMovingOrSizing)
			MoverStance:SetUserPlaced(true)
						
		elseif Inked.db.profile.MoverStancePoint == nil then
				MoverStance:SetPoint("BOTTOM", UIParent,Inked.db.profile.MoverStanceX,Inked.db.profile.MoverStanceY)
			else
				MoverStance:SetPoint(Inked.db.profile.MoverStancePoint, UIParent,Inked.db.profile.MoverStanceX,Inked.db.profile.MoverStanceY)
		end
		
		StanceButton1:ClearAllPoints();
		StanceButton1:SetPoint("LEFT", MoverStance, 0, 0)
		
end		
		local InkedLoginFrame=CreateFrame("Frame")
		InkedLoginFrame:RegisterEvent("PLAYER_LOGIN")
		InkedLoginFrame:RegisterEvent("CINEMATIC_STOP")
		InkedLoginFrame:SetScript("OnEvent", function(self, event) 
			MakeBarStance()									
		end)